/* 
 * Copyright (C) 2017 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.desktop.view;

import com.frojasg1.general.desktop.ImageFunctions;
import java.awt.Image;
import java.awt.Insets;
import java.awt.image.BufferedImage;
import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.SwingConstants;

/**
 *
 * @author Usuario
 */
public class ViewFunctions
{
	public static void addImageToButton( JButton button, String resourceName, Insets insets )
	{
		try
		{
			int xMargin = 0;
			int yMargin = 0;

			button.setVerticalTextPosition( SwingConstants.CENTER );
			button.setHorizontalTextPosition( SwingConstants.CENTER );

			if( insets != null )
			{
				xMargin = insets.left + insets.right;
				yMargin = insets.top + insets.bottom;

				button.setMargin( insets );
			}

			BufferedImage img = ImageIO.read(ClassLoader.getSystemClassLoader().getResourceAsStream(resourceName));
//			System.out.println( "Resource: " + resourceName + " button.getBounds() = " + button.getBounds() );
			Image resizedImage = ImageFunctions.resizeImage( img, button.getWidth()-xMargin, button.getHeight()-yMargin, null, null, null );
			button.setIcon(new ImageIcon(resizedImage));

		}
		catch (Throwable ex)
		{
			ex.printStackTrace();
		}
	}
}
